<!DOCTYPE html>
<html lang="en" dir="ltr" prefix="content: http://purl.org/rss/1.0/modules/content/  dc: http://purl.org/dc/terms/  foaf: http://xmlns.com/foaf/0.1/  og: http://ogp.me/ns#  rdfs: http://www.w3.org/2000/01/rdf-schema#  schema: http://schema.org/  sioc: http://rdfs.org/sioc/ns#  sioct: http://rdfs.org/sioc/types#  skos: http://www.w3.org/2004/02/skos/core#  xsd: http://www.w3.org/2001/XMLSchema# ">
  <head>
    <meta charset="utf-8" />
<link rel="canonical" href="http://default/blog/2021-04-14/configurar-xdebug3-para-depurar-codigo-con-vscode-usando-los-contenedores-wodby-4-0" />
<meta name="description" content="Con las últimas versiones de PHP 7.4 se ha cambiado de versión también en Xdebug, ahora las últimas versiones de php 7.4 y 8.x tiene Xdebug 3.x, y trae varios cambios respecto a la versión 2.x, vamos a ver como configurar el contenedor de Wodby 4 Drupal y el editor VSCode para poder depurar nuestro código.

 

Lo primero, en el archivo docker-compose.override.yml vamos a descomentar las siguientes opciones:


  php:
    environment:
#      SSH_AUTH_SOCK: /ssh-agent
#      # Read instructions at https://wodby.com/docs/stacks/php/local/#xdebug
      PHP_XDEBUG: 1
      PHP_XDEBUG_MODE: debug
#      PHP_IDE_CONFIG: serverName=my-ide
#      PHP_XDEBUG_IDEKEY: &quot;my-ide&quot;
#      PHP_XDEBUG_CLIENT_HOST: host.docker.internal # Docker 18.03+ Mac/Win
      PHP_XDEBUG_CLIENT_HOST: 172.17.0.1 # Linux
#      PHP_XDEBUG_CLIENT_HOST: 10.254.254.254 # macOS, Docker &lt; 18.03
#      PHP_XDEBUG_CLIENT_HOST: 10.0.75.1 # Windows, Docker &lt; 18.03
#      PHP_XDEBUG_LOG: /tmp/php-xdebug.log
      PHP_XDEBUG_REMOTE_AUTOSTART: 1
      PHP_XDEBUG_DEFAULT_ENABLE: 1
      PHP_XDEBUG_REMOTE_CONNECT_BACK: 0

 

Tenemos que regenerar el contenidor ejecutando: 


docker-compose up --build

 

Una vez configurado el contenedor tenemos que instalar el plugin de Xdebug para VScode, existen varios plugins de Xdebug para VSCode, yo he instado el creado por Felix Becker, tiene más de 4 millones de descargas, al instalarlo aparece en la barra de iconos de VSCode de la izquierda el icono de play/triangulo y un escarabajo..

 

 


  
      
  
    Image
                



          

  


 

Al pinchar en el icono de Xdebug muestra el siguiente texto:


  
      
  
    Image
                



          

  


 

Pincha en el enlace create a launch.json file, del listado de opciones del desplegable que se muestra seleccionamos PHP, y nos creará un archivo con el siguiente texto:" />
<meta name="Generator" content="Drupal 9 (https://www.drupal.org)" />
<meta name="MobileOptimized" content="width" />
<meta name="HandheldFriendly" content="true" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="shortcut icon" href="/themes/contrib/material_base/starterkits/material_compile/favicon.ico" type="image/vnd.microsoft.icon" />
<link rel="revision" href="http://default/blog/2021-04-14/configurar-xdebug3-para-depurar-codigo-con-vscode-usando-los-contenedores-wodby-4-0" />

    <title>Configurar Xdebug3 para depurar código con VSCode usando los contenedores wodby 4 drupal | Blog de Oskar</title>
    <link rel="stylesheet" media="all" href="/sites/default/files/css/css_3PcFAjRSdZ_bz3MJfz8L_RikGRUw4v0YNxuyLDOV8ww.css" />
<link rel="stylesheet" media="all" href="/sites/default/files/css/css_NyznZm3NpCaIvk4H9UoR0TjuyZOw0VQyBReYksZbsJM.css" />

    
  </head>
  <body class="one-sidebar sidebar-first navbar-fixed path-node page-node-type-article">
    <a href="#main-content" class="visually-hidden focusable">
      Skip to main content
    </a>
    
      <div class="dialog-off-canvas-main-canvas" data-off-canvas-main-canvas>
    <div id="page" class="layout-container">

  <div id="navbar">
    
    <!--
    
    
    -->
  </div>

  <div id="drawer-overlay"></div>
  <div id="drawer">
    
  </div>

  <header id="header" role="banner">
    <div id="header-content">
      
    </div>
    <div id="header-bg">
      
    </div>
  </header>

  
  <div id="content">
    
    <main role="main" id="main" class="container">
      <div id="main-content" tabindex="-1">
        <div class="card-holder">
            <div class="region region-breadcrumb">
    <div id="block-material-compile-breadcrumbs--2">
  
    
        <nav class="breadcrumb" role="navigation" aria-labelledby="system-breadcrumb">
    <h2 class="visually-hidden">Breadcrumb</h2>
    <ol>
          <li>
                  <a href="/">Home</a>
              </li>
        </ol>
  </nav>

  </div>

  </div>

            <div class="region region-highlighted">
    <div data-drupal-messages-fallback class="hidden"></div>

  </div>

          

          <div class="layout-content">
              <div class="region region-content">
    <div id="block-material-compile-page-title--5">
  
    
      
  <h1><span property="schema:name">Configurar Xdebug3 para depurar código con VSCode usando los contenedores wodby 4 drupal</span>
</h1>


  </div>
<div id="block-material-compile-content--5">
  
    
      <article data-history-node-id="15" role="article" about="/blog/2021-04-14/configurar-xdebug3-para-depurar-codigo-con-vscode-usando-los-contenedores-wodby-4-0" typeof="schema:Article">

  
      <span property="schema:name" content="Configurar Xdebug3 para depurar código con VSCode usando los contenedores wodby 4 drupal" class="hidden"></span>


      <footer>
      <article typeof="schema:Person" about="/user/1">
  </article>

      <div>
        Submitted by <span rel="schema:author"><span lang="" about="/user/1" typeof="schema:Person" property="schema:name" datatype="">Oskar</span></span>
 on <span property="schema:dateCreated" content="2021-04-14T21:34:20+00:00">Wed, 04/14/2021 - 23:34</span>
          <span property="schema:dateCreated" content="2021-04-14T21:34:20+00:00" class="hidden"></span>

      </div>
    </footer>
  
  <div>
    
            <div property="schema:text" class="field field-name-body field-type-text-with-summary field-label-hidden field-item"><p>Con las últimas versiones de PHP 7.4 se ha cambiado de versión también en Xdebug, ahora las últimas versiones de php 7.4 y 8.x tiene Xdebug 3.x, y trae varios cambios respecto a la versión 2.x, vamos a ver como configurar el contenedor de Wodby 4 Drupal y el editor VSCode para poder depurar nuestro código.</p>

<p> </p>

<p>Lo primero, en el archivo docker-compose.override.yml vamos a descomentar las siguientes opciones:</p>

<pre>
<code class="language-bash">  php:
    environment:
#      SSH_AUTH_SOCK: /ssh-agent
#      # Read instructions at https://wodby.com/docs/stacks/php/local/#xdebug
      PHP_XDEBUG: 1
      PHP_XDEBUG_MODE: debug
#      PHP_IDE_CONFIG: serverName=my-ide
#      PHP_XDEBUG_IDEKEY: "my-ide"
#      PHP_XDEBUG_CLIENT_HOST: host.docker.internal # Docker 18.03+ Mac/Win
      PHP_XDEBUG_CLIENT_HOST: 172.17.0.1 # Linux
#      PHP_XDEBUG_CLIENT_HOST: 10.254.254.254 # macOS, Docker &lt; 18.03
#      PHP_XDEBUG_CLIENT_HOST: 10.0.75.1 # Windows, Docker &lt; 18.03
#      PHP_XDEBUG_LOG: /tmp/php-xdebug.log
      PHP_XDEBUG_REMOTE_AUTOSTART: 1
      PHP_XDEBUG_DEFAULT_ENABLE: 1
      PHP_XDEBUG_REMOTE_CONNECT_BACK: 0</code></pre>

<p> </p>

<p>Tenemos que regenerar el contenidor ejecutando: </p>

<pre>
<code class="language-bash">docker-compose up --build</code></pre>

<p> </p>

<p>Una vez configurado el contenedor tenemos que instalar el plugin de Xdebug para VScode, existen varios plugins de Xdebug para VSCode, yo he instado el creado por Felix Becker, tiene más de 4 millones de descargas, al instalarlo aparece en la barra de iconos de VSCode de la izquierda el icono de play/triangulo y un escarabajo..</p>

<p> </p>

<p> </p>

<article class="align-center">
  
      
  <div class="field field-name-field-media-image field-type-image field-label-visually_hidden">
    <div class="field-label visually-hidden">Image</div>
              <div class="field-item">  <img src="/sites/default/files/styles/large/public/2021-04/Captura%20de%20pantalla%20de%202021-04-14%2023-52-51.png?itok=cVF1AMeL" width="468" height="447" alt="Botón activación xdebug VSCode" loading="lazy" typeof="foaf:Image" />


</div>
          </div>

  </article>


<p> </p>

<p>Al pinchar en el icono de Xdebug muestra el siguiente texto:</p>

<article class="align-center">
  
      
  <div class="field field-name-field-media-image field-type-image field-label-visually_hidden">
    <div class="field-label visually-hidden">Image</div>
              <div class="field-item">  <img src="/sites/default/files/styles/large/public/2021-04/Captura%20de%20pantalla%20de%202021-04-14%2023-49-30.png?itok=Mxo0r7wF" width="476" height="366" alt="Configurar xdebug en VSCode" loading="lazy" typeof="foaf:Image" />


</div>
          </div>

  </article>


<p> </p>

<p>Pincha en el enlace create a launch.json file, del listado de opciones del desplegable que se muestra seleccionamos PHP, y nos creará un archivo con el siguiente texto:</p>

<pre>
<code class="language-json">{
    // Use IntelliSense to learn about possible attributes.
    // Hover to view descriptions of existing attributes.
    // For more information, visit: https://go.microsoft.com/fwlink/?linkid=830387
    "version": "0.2.0",
    "configurations": [
        {
            "name": "Listen for Xdebug",
            "type": "php",
            "request": "launch",
            "port": 9000
        },
        {
            "name": "Launch currently open script",
            "type": "php",
            "request": "launch",
            "program": "${file}",
            "cwd": "${fileDirname}",
            "port": 9000
        }
    ]
}</code></pre>

<p> </p>

<p>Lo cambiamos por:</p>

<pre>
<code class="language-json">{
    // Use IntelliSense to learn about possible attributes.
    // Hover to view descriptions of existing attributes.
    // For more information, visit: https://go.microsoft.com/fwlink/?linkid=830387
    "version": "0.2.0",
    "configurations": [
        {

            "name": "Tome",
            "type": "php",
            "request": "launch",
            "port": 9003,

            "pathMappings": {
                "/var/www/html": "${workspaceRoot}"
            }
        }
    ]
}</code></pre>

<ul>
	<li>Name: es el nombre que identifica la configuración.</li>
	<li>Port: 9003 es el nuevo puerto de Xdebug.</li>
	<li>PathMappings: es la ruta de la aplicación dentro del contenedor y en la máquina host.</li>
</ul>

<p> </p>

<p>Ahora simplemente hay que indicar el breakpoint en el código y al ejecutar la aplicación si pasa por el breakpoint señalado se parará la ejecución de la petición.</p>

<p> </p>

<article class="align-center">
  
      
  <div class="field field-name-field-media-image field-type-image field-label-visually_hidden">
    <div class="field-label visually-hidden">Image</div>
              <div class="field-item">  <img src="/sites/default/files/styles/large/public/2021-04/Captura%20de%20pantalla%20de%202021-04-15%2000-06-26.png?itok=ubQJGJvW" width="480" height="348" alt="Breakpoint en VSCode" loading="lazy" typeof="foaf:Image" />


</div>
          </div>

  </article>

</div>
      
  <div class="field field-name-field-tags field-type-entity-reference field-label-above">
    <div class="field-label">Tags</div>
          <div class="field-items">
              <div class="field-item"><a href="/tag/calidad" property="schema:about" hreflang="en">Calidad</a></div>
          <div class="field-item"><a href="/tag/xdebug3" property="schema:about" hreflang="en">Xdebug3</a></div>
          <div class="field-item"><a href="/tag/vscode" property="schema:about" hreflang="en">VSCode</a></div>
              </div>
      </div>

  </div>

</article>

  </div>

  </div>

          </div>
        </div>
              </div>
              <aside id="sidebar-first" class="sidebar layout-sidebar-first" role="complementary">
            <div class="region region-sidebar-first">
    <div id="block-presentaciondelblog">
  
    
      
            <div class="field field-name-body field-type-text-with-summary field-label-hidden field-item"><p>Este es mi blog, "el blog de Oskar", Me puedes escribir vía <a href="https://www.linkedin.com/in/oskarcalvo/">Linkedin</a></p>
</div>
      
  </div>
<div class="views-element-container" id="block-views-block-last-10-articles-block-1">
  
      <h2>Últimos artículos</h2>
    
      <div><div class="js-view-dom-id-6243558343cef6cc53fbf9151e16e3940045c3d88e497f6a5eb20abe1137dcbc">
  
  
  

  
  
  

  <div class="item-list">
  
  <ul>

          <li><span class="views-field views-field-title"><span class="field-content"><a href="/blog/2021-04-14/configurar-xdebug3-para-depurar-codigo-con-vscode-usando-los-contenedores-wodby-4" hreflang="en">Configurar Xdebug3 para depurar código con VSCode usando los contenedores wodby 4 drupal</a></span></span> - <span class="views-field views-field-created"><span class="field-content">2021-04-14</span></span></li>
          <li><span class="views-field views-field-title"><span class="field-content"><a href="/blog/2021-04-14/configurar-xdebug3-para-depurar-codigo-con-vscode-usando-los-contenedores-wodby-4-0" hreflang="en">Configurar Xdebug3 para depurar código con VSCode usando los contenedores wodby 4 drupal</a></span></span> - <span class="views-field views-field-created"><span class="field-content">2021-04-14</span></span></li>
          <li><span class="views-field views-field-title"><span class="field-content"><a href="/blog/2021-04-05/drupal-y-codesniffer-para-mantener-la-calidad-del-codigo-de-nuestros-proyectos" hreflang="en">Drupal y CodeSniffer para mantener la calidad del código de nuestros proyectos</a></span></span> - <span class="views-field views-field-created"><span class="field-content">2021-04-05</span></span></li>
          <li><span class="views-field views-field-title"><span class="field-content"><a href="/blog/2021-03-20/tome-y-gitlab-pages-para-crear-paginas-estaticas-de-forma-rapida-y-sencilla" hreflang="en">Tome y gitlab pages para crear páginas estáticas de forma rápida y sencilla.</a></span></span> - <span class="views-field views-field-created"><span class="field-content">2021-03-20</span></span></li>
          <li><span class="views-field views-field-title"><span class="field-content"><a href="/blog/2021-03-13/ovh-y-lo-inesperado" hreflang="en">OVH y lo inesperado</a></span></span> - <span class="views-field views-field-created"><span class="field-content">2021-03-13</span></span></li>
    
  </ul>

</div>

    

  
  

  
  
</div>
</div>

  </div>

  </div>

        </aside>
      
      
    </main>
    
  </div>
  <footer id="footer" role="contentinfo">
    
    <div id="footer-content">
      
    </div>
  </footer>

</div>
  </div>

    
    <script type="application/json" data-drupal-selector="drupal-settings-json">{"path":{"baseUrl":"\/","scriptPath":null,"pathPrefix":"","currentPath":"node\/15","currentPathIsAdmin":false,"isFront":false,"currentLanguage":"en"},"pluralDelimiter":"\u0003","suppressDeprecationErrors":true,"user":{"uid":0,"permissionsHash":"9b4d8556262e2e38b0af236cf1dbcd3346d83a0d1ed154b46f4ac15d03ce2257"}}</script>
<script src="/sites/default/files/js/js_b7BC_YTtFXAsUEtL5nCoXPJ7aIHnk5fcdkjSQ4XyTbg.js"></script>

  </body>
</html>
